require ('globals')
require ('selection_with_upbeat')

function phase_shift (frame)
  local frm = math.floor(frame)  
--  get_init_env()
  not_sliced_ok ()
  local range = selection_end - selection_start +1
  local point = math.fmod(math.fmod(frm,range)+range,range) -- frame:+or-,OK
  if point == 0 then
    return nil
  end
  
  create_new (init_number_of_frames)
  new_buffer:prepare_sample_data_changes()
  
  if selection_start >1 then
    for ch = 1,init_number_of_channels do
      for fr = 1,(selection_start -1) do
        new_buffer
        :set_sample_data(
          ch,fr,
          init_buffer
          :sample_data(ch,fr))
      end
    end
  end
    
  if selection_end < init_number_of_frames then
    for ch = 1,init_number_of_channels do
      for fr = (selection_end +1),init_number_of_frames do
        new_buffer
          :set_sample_data(
            ch,fr,
            init_buffer
            :sample_data(ch,fr))
      end
    end
  end


  for ch = 1,init_number_of_channels do
    for fr =(selection_start + point),selection_end do
      new_buffer
      :set_sample_data(
        ch,(fr - point),
        init_buffer
        :sample_data(ch,fr))
    end
  end      
  if point >=1 then    
    for ch = 1,init_number_of_channels do
      for fr = selection_start,(selection_start + point -1) do
        new_buffer
        :set_sample_data(
          ch,(fr + range - point),
          init_buffer
          :sample_data(ch,fr))
      end
    end      
  end
  
  new_buffer:finalize_sample_data_changes()
      
  new_sample.loop_start
  = init_loop_start
  new_sample.loop_end
  = init_loop_end        

  init_sample:copy_from(new_sample)
  init_inst:delete_sample_at(init_sample_index + 1)
  init_buffer.selection_start = selection_start
  init_buffer.selection_end = selection_end  
end

-------------------------------------
function phase_shift_with_ratio (ratio)
  get_init_env()
  local range = selection_end - selection_start +1  
  phase_shift (range * ratio)
end

function phase_shift_fine (frame)
  get_init_env()
  phase_shift (frame)
end


