require ('globals')
require ('selection_with_upbeat')

-- I͈͂ŕ`Ȑ̌`̒`B
-- 0~1XőI͈͂̎ԁAYVolume\悤Ȋ֐^B
-- x=0:I͈͂̎n_Ax=1:I͈͂̏I_B
-- y=0:Ay=1:Max Volume,܂͌VolumeB

-- sin wave 2pi
function sin_2pi_fn(x)
  local y = math.sin(x*2*math.pi) 
  return y
end

-- sin wave pi/2 - 3pi/2
function sin_pi_fn(x)
  local y = math.sin((x + (1/2))*math.pi) 
  return y
end

-- saw wave
function saw_fn(x)
  local y =
  2*(x - math.floor(x + (1/2)))
  return y
end

-- Square wave
function square_fn(x)
  local y =0
  if
    x == 0 then y =0
    elseif
      0 < x and x < (1/2) then y = 1
      elseif
        x == (1/2) then y = 0
        elseif
          (1/2)< x and x <1 then y = -1
          elseif
            x == 1 then y = 0
            end
  return y
end

-- triangle wave
function triangle_fn(x)
  local y=0
  if
    0 <= x and x <(1/4) then y = 4*x
    elseif
      (1/4)<= x and x < (3/4) then y = -4*x +2
      elseif
        (3/4)<= x and x <=1 then y = 4*x -4
        end
  return y
end
        
-- multiply 11/12
function multiply_11on12_fn(x)
  return 11/12
end

-- multiply 13/12
function multiply_13on12_fn(x)
  return 13/12
end

-- [1A7/8A̓񎟋Ȑ
function center_7on8_fn(x)
  local y = (1/2)*(x-(1/2))^2 +(7/8) 
  return y
end

-- [1A9/8A̓񎟋Ȑ
function center_9on8_fn(x)
  local y = -(1/2)*(x-(1/2))^2 +(9/8) 
  return y
end

-- White Noise
function white_noise_fn(x)
  local y = math.random()*2 -1
  return y
end

-- Pink Noise?
function pink_noise_fn(x)
  local r,rx,ry
  rx= math.random()
  ry= math.random()
  if ry <= (rx)
  then r = rx
  else r = 1-rx
  end
  return (math.random(0,1)*2 -1)*r
end


-----------------------------------------------------
-- VSampleĂRs[āAIA
-- ƂȎĂ܂B

-- I͈͂ɔg`쐬B
function make_wave (fn)
  get_init_env()
  not_sliced_ok ()  
  local selection_range = selection_end - selection_start
  
  create_new (init_number_of_frames)
  new_buffer:prepare_sample_data_changes()

  for ch = 1,init_number_of_channels do
    for fr = 1,selection_start-1 do
      new_buffer
      :set_sample_data(
        ch,fr,
        init_buffer
        :sample_data(ch,fr))
    end
    for fr = selection_start,selection_end do
      new_buffer
      :set_sample_data(
        ch,fr,
        (fn((fr-selection_start)/selection_range)))
    end        
    for fr = selection_end+1,init_number_of_frames do
      new_buffer
      :set_sample_data(
        ch,fr,
        init_buffer
        :sample_data(ch,fr))  
    end
  end      
  new_buffer:finalize_sample_data_changes()
  
  new_sample.loop_start
  = init_loop_start
  new_sample.loop_end
  = init_loop_end        

  init_sample:copy_from(new_sample)
  init_inst:delete_sample_at(init_sample_index + 1)
  init_buffer.selection_start = selection_start
  init_buffer.selection_end = selection_end      
end


-- ֐fngāAI͈͂FadeB(|Zj
function set_fade (fn)
  get_init_env()
  not_sliced_ok ()  
  local selection_range = selection_end - selection_start
  
  create_new (init_number_of_frames)

  new_buffer:prepare_sample_data_changes()
  
  for ch = 1,init_number_of_channels do
    for fr = 1,selection_start-1 do
      new_buffer
      :set_sample_data(
        ch,fr,
        init_buffer
        :sample_data(ch,fr))
    end
    for fr = selection_start,selection_end do
      new_buffer
      :set_sample_data(
        ch,fr,
        (fn((fr-selection_start)/selection_range)*(init_buffer
          :sample_data(ch,fr))))
    end        
    for fr = selection_end+1,init_number_of_frames do
      new_buffer
      :set_sample_data(
        ch,fr,
        init_buffer
        :sample_data(ch,fr))  
    end
  end      
  new_buffer:finalize_sample_data_changes()
  
  new_sample.loop_start
  = init_loop_start
  new_sample.loop_end
  = init_loop_end        
  
  init_sample:copy_from(new_sample)
  init_inst:delete_sample_at(init_sample_index + 1)
  init_buffer.selection_start = selection_start
  init_buffer.selection_end = selection_end      
end


--testpBRgAEg
--make_wave(sin_fn)
--set_fade(center_7on8_fn)

